Whamcloud - gitweb
LU-793 ptlrpc: fix ptlrpc_request_change_export()
[fs/lustre-release.git] / lustre / tests / recovery-small.sh
index ee03c9a..0cdc7f7 100755 (executable)
@@ -2,8 +2,8 @@
 
 set -e
 
-#         bug  5494 5493
-ALWAYS_EXCEPT="24   52 $RECOVERY_SMALL_EXCEPT"
+#         bug  5493  LU2034
+ALWAYS_EXCEPT="52    60      $RECOVERY_SMALL_EXCEPT"
 
 export MULTIOP=${MULTIOP:-multiop}
 PTLDEBUG=${PTLDEBUG:--1}
@@ -19,6 +19,10 @@ require_dsh_mds || exit 0
 #                                   1  2.5  2.5    4    4          (min)"
 [ "$SLOW" = "no" ] && EXCEPT_SLOW="17  26a  26b    50   51     57"
 
+[ $(facet_fstype $SINGLEMDS) = "zfs" ] &&
+# bug number for skipped test:       LU-2194 LU-2547
+       ALWAYS_EXCEPT="$ALWAYS_EXCEPT 19b     24a 24b"
+
 build_test_filter
 
 # Allow us to override the setup if we already have a mounted system by
@@ -29,64 +33,90 @@ CLEANUP=${CLEANUP:-""}
 check_and_setup_lustre
 
 assert_DIR
-rm -rf $DIR/[df][0-9]*
+rm -rf $DIR/d[0-9]* $DIR/f.${TESTSUITE}*
 
 test_1() {
-    drop_request "mcreate $DIR/f1"  || return 1
-    drop_reint_reply "mcreate $DIR/f2"    || return 2
-}
-run_test 1 "mcreate: drop req, drop rep"
+       local f1="$DIR/$tfile"
+       local f2="$DIR/$tfile.2"
 
-test_2() {
-    drop_request "tchmod 111 $DIR/f2"  || return 1
-    drop_reint_reply "tchmod 666 $DIR/f2"    || return 2
-}
-run_test 2 "chmod: drop req, drop rep"
+       drop_request "mcreate $f1" ||
+               error_noexit "create '$f1': drop req"
 
-test_3() {
-    drop_request "statone $DIR/f2" || return 1
-    drop_reply "statone $DIR/f2"   || return 2
-}
-run_test 3 "stat: drop req, drop rep"
+       drop_reint_reply "mcreate $f2" ||
+               error_noexit "create '$f2': drop rep"
+
+       drop_request "tchmod 111 $f2" ||
+               error_noexit "chmod '$f2': drop req"
+
+       drop_reint_reply "tchmod 666 $f2" ||
+               error_noexit "chmod '$f2': drop rep"
 
-SAMPLE_NAME=f0.recovery-small.junk
-SAMPLE_FILE=$TMP/$SAMPLE_NAME
-# make this big, else test 9 doesn't wait for bulk -- bz 5595
-dd if=/dev/urandom of=$SAMPLE_FILE bs=1M count=4
+       drop_request "statone $f2" ||
+               error_noexit "stat '$f2': drop req"
+
+       drop_reply  "statone $f2" ||
+               error_noexit "stat '$f2': drop rep"
+}
+run_test 1 "create, chmod, stat: drop req, drop rep"
 
 test_4() {
-    do_facet client "cp $SAMPLE_FILE $DIR/$SAMPLE_NAME" || return 1
-    drop_request "cat $DIR/$SAMPLE_NAME > /dev/null"   || return 2
-    drop_reply "cat $DIR/$SAMPLE_NAME > /dev/null"     || return 3
+       local t=$DIR/$tfile
+       do_facet_create_file client $t 10K ||
+               error_noexit "Create file $t"
+
+       drop_request "cat $t > /dev/null" ||
+               error_noexit "Open request for $t file"
+
+       drop_reply "cat $t > /dev/null" ||
+               error_noexit "Open replay for $t file"
 }
 run_test 4 "open: drop req, drop rep"
 
-RENAMED_AGAIN=$DIR/f0.renamed-again
-
 test_5() {
-    drop_request "mv $DIR/$SAMPLE_NAME $DIR/$tfile-renamed" || return 1
-    drop_reint_reply "mv $DIR/$tfile-renamed $RENAMED_AGAIN" || return 2
-    do_facet client "checkstat -v $RENAMED_AGAIN"  || return 3
+       local T=$DIR/$tfile
+       local R="$T-renamed"
+       local RR="$T-renamed-again"
+       do_facet_create_file client $T 10K ||
+               error_noexit "Create file $T"
+
+       drop_request "mv $T $R" ||
+               error_noexit "Rename $T"
+
+       drop_reint_reply "mv $R $RR" ||
+               error_noexit "Failed rename replay on $R"
+
+       do_facet client "checkstat -v $RR" ||
+               error_noexit "checkstat error on $RR"
+
+       do_facet client "rm $RR" ||
+               error_noexit "Can't remove file $RR"
 }
 run_test 5 "rename: drop req, drop rep"
 
-[ ! -e $RENAMED_AGAIN ] && cp $SAMPLE_FILE $RENAMED_AGAIN
-LINK1=$DIR/f0.link1
-LINK2=$DIR/f0.link2
-
 test_6() {
-    drop_request "mlink $RENAMED_AGAIN $LINK1" || return 1
-    drop_reint_reply "mlink $RENAMED_AGAIN $LINK2"   || return 2
-}
-run_test 6 "link: drop req, drop rep"
+       local T=$DIR/$tfile
+       local LINK1=$DIR/$tfile.link1
+       local LINK2=$DIR/$tfile.link2
+
+       do_facet_create_file client $T 10K ||
+               error_noexit "Create file $T"
+
+       drop_request "mlink $T $LINK1" ||
+               error_noexit "mlink request for $T"
+
+       drop_reint_reply "mlink $T $LINK2" ||
+               error_noexit "mlink reply for $T"
+
+       drop_request "munlink $LINK1" ||
+               error_noexit "munlink request for $T"
 
-[ ! -e $LINK1 ] && mlink $RENAMED_AGAIN $LINK1
-[ ! -e $LINK2 ] && mlink $RENAMED_AGAIN $LINK2
-test_7() {
-    drop_request "munlink $LINK1"   || return 1
-    drop_reint_reply "munlink $LINK2"     || return 2
+       drop_reint_reply "munlink $LINK2" ||
+               error_noexit "munlink reply for $T"
+
+       do_facet client "rm $T" ||
+               error_noexit "Can't remove file $T"
 }
-run_test 7 "unlink: drop req, drop rep"
+run_test 6 "link, unlink: drop req, drop rep"
 
 #bug 1423
 test_8() {
@@ -96,67 +126,94 @@ run_test 8 "touch: drop rep (bug 1423)"
 
 #bug 1420
 test_9() {
-    remote_ost_nodsh && skip "remote OST with nodsh" && return 0
+       remote_ost_nodsh && skip "remote OST with nodsh" && return 0
 
-    pause_bulk "cp /etc/profile $DIR/$tfile"       || return 1
-    do_facet client "cp $SAMPLE_FILE $DIR/${tfile}.2"  || return 2
-    do_facet client "sync"
-    do_facet client "rm $DIR/$tfile $DIR/${tfile}.2" || return 3
+       local t1=${tfile}.1
+       local t2=${tfile}.2
+       do_facet_random_file client $TMP/$tfile 1K ||
+               error_noexit "Create random file $TMP/$tfile"
+       # make this big, else test 9 doesn't wait for bulk -- bz 5595
+       do_facet_create_file client $TMP/$t1 4M ||
+               error_noexit "Create file $TMP/$t1"
+       do_facet client "cp $TMP/$t1 $DIR/$t1" ||
+               error_noexit "Can't copy to $DIR/$t1 file"
+       pause_bulk "cp $TMP/$tfile $DIR/$tfile" ||
+               error_noexit "Can't pause_bulk copy"
+       do_facet client "cp $TMP/$t1 $DIR/$t2" ||
+               error_noexit "Can't copy file"
+       do_facet client "sync"
+       do_facet client "rm $DIR/$tfile $DIR/$t2 $DIR/$t1" ||
+               error_noexit "Can't remove files"
+       do_facet client "rm $TMP/$t1 $TMP/$tfile"
 }
 run_test 9 "pause bulk on OST (bug 1420)"
 
 #bug 1521
 test_10() {
-    do_facet client mcreate $DIR/$tfile        || return 1
-    drop_bl_callback "chmod 0777 $DIR/$tfile"  || echo "evicted as expected"
-    # wait for the mds to evict the client
-    #echo "sleep $(($TIMEOUT*2))"
-    #sleep $(($TIMEOUT*2))
-    do_facet client touch $DIR/$tfile || echo "touch failed, evicted"
-    do_facet client checkstat -v -p 0777 $DIR/$tfile  || return 3
-    do_facet client "munlink $DIR/$tfile"
+       do_facet client mcreate $DIR/$tfile ||
+               { error "mcreate failed: $?"; return 1; }
+       drop_bl_callback "chmod 0777 $DIR/$tfile"  || echo "evicted as expected"
+       # wait for the mds to evict the client
+       #echo "sleep $(($TIMEOUT*2))"
+       #sleep $(($TIMEOUT*2))
+       do_facet client touch $DIR/$tfile || echo "touch failed, evicted"
+       do_facet client checkstat -v -p 0777 $DIR/$tfile ||
+               { error "client checkstat failed: $?"; return 3; }
+       do_facet client "munlink $DIR/$tfile"
+       # allow recovery to complete
+       client_up || client_up || sleep $TIMEOUT
 }
 run_test 10 "finish request on server after client eviction (bug 1521)"
 
 #bug 2460
 # wake up a thread waiting for completion after eviction
 test_11(){
-    do_facet client $MULTIOP $DIR/$tfile Ow  || return 1
-    do_facet client $MULTIOP $DIR/$tfile or  || return 2
+       do_facet client $MULTIOP $DIR/$tfile Ow  ||
+               { error "multiop write failed: $?"; return 1; }
+       do_facet client $MULTIOP $DIR/$tfile or  ||
+               { error "multiop read failed: $?"; return 2; }
 
-    cancel_lru_locks osc
+       cancel_lru_locks osc
 
-    do_facet client $MULTIOP $DIR/$tfile or  || return 3
-    drop_bl_callback $MULTIOP $DIR/$tfile Ow || echo "evicted as expected"
+       do_facet client $MULTIOP $DIR/$tfile or  ||
+               { error "multiop read failed: $?"; return 3; }
+       drop_bl_callback $MULTIOP $DIR/$tfile Ow || echo "evicted as expected"
 
-    do_facet client munlink $DIR/$tfile  || return 4
+       do_facet client munlink $DIR/$tfile ||
+               { error "munlink failed: $?"; return 4; }
+       # allow recovery to complete
+       client_up || client_up || sleep $TIMEOUT
 }
 run_test 11 "wake up a thread waiting for completion after eviction (b=2460)"
 
 #b=2494
 test_12(){
-    $LCTL mark $MULTIOP $DIR/$tfile OS_c
-    do_facet $SINGLEMDS "lctl set_param fail_loc=0x115"
-    clear_failloc $SINGLEMDS $((TIMEOUT * 2)) &
-    multiop_bg_pause $DIR/$tfile OS_c || return 1
-    PID=$!
+       $LCTL mark $MULTIOP $DIR/$tfile OS_c
+       do_facet $SINGLEMDS "lctl set_param fail_loc=0x115"
+       clear_failloc $SINGLEMDS $((TIMEOUT * 2)) &
+       multiop_bg_pause $DIR/$tfile OS_c ||
+               { error "multiop failed: $?"; return 1; }
+       PID=$!
 #define OBD_FAIL_MDS_CLOSE_NET           0x115
-    kill -USR1 $PID
-    echo "waiting for multiop $PID"
-    wait $PID || return 2
-    do_facet client munlink $DIR/$tfile  || return 3
+       kill -USR1 $PID
+       echo "waiting for multiop $PID"
+       wait $PID || { error "wait for multiop faile: $?"; return 2; }
+       do_facet client munlink $DIR/$tfile ||
+               { error "client munlink failed: $?"; return 3; }
+       # allow recovery to complete
+       client_up || client_up || sleep $TIMEOUT
 }
 run_test 12 "recover from timed out resend in ptlrpcd (b=2494)"
 
 # Bug 113, check that readdir lost recv timeout works.
 test_13() {
-    mkdir -p $DIR/$tdir || return 1
-    touch $DIR/$tdir/newentry || return
+       mkdir -p $DIR/$tdir || { error "mkdir failed: $?"; return 1; }
+       touch $DIR/$tdir/newentry || { error "touch failed: $?"; return 2; }
 # OBD_FAIL_MDS_READPAGE_NET|OBD_FAIL_ONCE
-    do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000104"
-    ls $DIR/$tdir || return 3
-    do_facet $SINGLEMDS "lctl set_param fail_loc=0"
-    rm -rf $DIR/$tdir || return 4
+       do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000104"
+       ls $DIR/$tdir || { error "ls failed: $?"; return 3; }
+       do_facet $SINGLEMDS "lctl set_param fail_loc=0"
+       rm -rf $DIR/$tdir || { error "remove test dir failed: $?"; return 4; }
 }
 run_test 13 "mdc_readpage restart test (bug 1138)"
 
@@ -188,22 +245,25 @@ start_read_ahead() {
 }
 
 test_16() {
-    remote_ost_nodsh && skip "remote OST with nodsh" && return 0
+       remote_ost_nodsh && skip "remote OST with nodsh" && return 0
 
-    do_facet client cp $SAMPLE_FILE $DIR
-    sync
-    stop_read_ahead
+       do_facet_random_file client $TMP/$tfile 100K ||
+               { error_noexit "Create random file $TMP/$T" ; return 0; }
+       do_facet client "cp $TMP/$tfile $DIR/$tfile" ||
+               { error_noexit "Copy to $DIR/$tfile file" ; return 0; }
+       sync
+       stop_read_ahead
 
 #define OBD_FAIL_PTLRPC_BULK_PUT_NET 0x504 | OBD_FAIL_ONCE
-    do_facet ost1 "lctl set_param fail_loc=0x80000504"
-    cancel_lru_locks osc
-    # OST bulk will time out here, client resends
-    do_facet client "cmp $SAMPLE_FILE $DIR/${SAMPLE_FILE##*/}" || return 1
-    do_facet ost1 lctl set_param fail_loc=0
-    # give recovery a chance to finish (shouldn't take long)
-    sleep $TIMEOUT
-    do_facet client "cmp $SAMPLE_FILE $DIR/${SAMPLE_FILE##*/}" || return 2
-    start_read_ahead
+       do_facet ost1 "lctl set_param fail_loc=0x80000504"
+       cancel_lru_locks osc
+       # OST bulk will time out here, client resends
+       do_facet client "cmp $TMP/$tfile $DIR/$tfile" || return 1
+       do_facet ost1 lctl set_param fail_loc=0
+       # give recovery a chance to finish (shouldn't take long)
+       sleep $TIMEOUT
+       do_facet client "cmp $TMP/$tfile $DIR/$tfile" || return 2
+       start_read_ahead
 }
 run_test 16 "timeout bulk put, don't evict client (2732)"
 
@@ -212,6 +272,10 @@ test_17() {
 
     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
 
+       local SAMPLE_FILE=$TMP/$tfile
+       do_facet_random_file client $SAMPLE_FILE 20K ||
+               { error_noexit "Create random file $SAMPLE_FILE" ; return 0; }
+
     # With adaptive timeouts, bulk_get won't expire until adaptive_timeout_max
     if at_is_enabled; then
         at_max_saved=$(at_max_get ost1)
@@ -242,6 +306,9 @@ run_test 17 "timeout bulk get, don't evict client (2732)"
 test_18a() {
     [ -z ${ost2_svc} ] && skip_env "needs 2 osts" && return 0
 
+       do_facet_create_file client $TMP/$tfile 20K ||
+               { error_noexit "Create file $TMP/$tfile" ; return 0; }
+
     do_facet client mkdir -p $DIR/$tdir
     f=$DIR/$tdir/$tfile
 
@@ -256,7 +323,7 @@ test_18a() {
         error "$f: stripe_index $stripe_index != 1" && return
     fi
 
-    do_facet client cp $SAMPLE_FILE $f
+    do_facet client cp $TMP/$tfile $f
     sync
     local osc2dev=`lctl get_param -n devices | grep ${ost2_svc}-osc- | egrep -v 'MDT' | awk '{print $1}'`
     $LCTL --device $osc2dev deactivate || return 3
@@ -273,6 +340,9 @@ run_test 18a "manual ost invalidate clears page cache immediately"
 test_18b() {
     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
 
+       do_facet_create_file client $TMP/$tfile 20K ||
+               { error_noexit "Create file $TMP/$tfile" ; return 0; }
+
     do_facet client mkdir -p $DIR/$tdir
     f=$DIR/$tdir/$tfile
 
@@ -286,7 +356,7 @@ test_18b() {
         error "$f: stripe_index $stripe_index != 0" && return
     fi
 
-    do_facet client cp $SAMPLE_FILE $f
+    do_facet client cp $TMP/$tfile $f
     sync
     ost_evict_client
     # allow recovery to complete
@@ -303,6 +373,9 @@ run_test 18b "eviction and reconnect clears page cache (2766)"
 test_18c() {
     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
 
+       do_facet_create_file client $TMP/$tfile 20K ||
+               { error_noexit "Create file $TMP/$tfile" ; return 0; }
+
     do_facet client mkdir -p $DIR/$tdir
     f=$DIR/$tdir/$tfile
 
@@ -316,7 +389,7 @@ test_18c() {
         error "$f: stripe_index $stripe_index != 0" && return
     fi
 
-    do_facet client cp $SAMPLE_FILE $f
+    do_facet client cp $TMP/$tfile $f
     sync
     ost_evict_client
 
@@ -340,20 +413,26 @@ test_19a() {
        local BEFORE=`date +%s`
        local EVICT
 
-       mount_client $DIR2
+       mount_client $DIR2 || error "failed to mount $DIR2"
 
-       do_facet client mcreate $DIR/$tfile        || return 1
-       drop_ldlm_cancel "chmod 0777 $DIR2"
+       # cancel cached locks from OST to avoid eviction from it
+       cancel_lru_locks osc
+
+       do_facet client "stat $DIR > /dev/null"  ||
+               error "failed to stat $DIR: $?"
+       drop_ldlm_cancel "chmod 0777 $DIR2" ||
+               error "failed to chmod $DIR2"
 
        umount_client $DIR2
-       do_facet client "munlink $DIR/$tfile"
 
        # let the client reconnect
-       sleep 5
+       client_reconnect
        EVICT=$(do_facet client $LCTL get_param mdc.$FSNAME-MDT*.state | \
            awk -F"[ [,]" '/EVICTED]$/ { if (mx<$4) {mx=$4;} } END { print mx }')
 
-       [ ! -z "$EVICT" ] && [[ $EVICT -gt $BEFORE ]] || error "no eviction"
+       [ ! -z "$EVICT" ] && [[ $EVICT -gt $BEFORE ]] ||
+               (do_facet client $LCTL get_param mdc.$FSNAME-MDT*.state;
+                   error "no eviction: $EVICT before:$BEFORE")
 }
 run_test 19a "test expired_lock_main on mds (2867)"
 
@@ -361,22 +440,61 @@ test_19b() {
        local BEFORE=`date +%s`
        local EVICT
 
-       mount_client $DIR2
+       mount_client $DIR2 || error "failed to mount $DIR2: $?"
 
-       do_facet client $MULTIOP $DIR/$tfile Ow  || return 1
-       drop_ldlm_cancel $MULTIOP $DIR2/$tfile Ow
-       umount_client $DIR2
-       do_facet client munlink $DIR/$tfile
+       # cancel cached locks from MDT to avoid eviction from it
+       cancel_lru_locks mdc
+
+       do_facet client $MULTIOP $DIR/$tfile Ow ||
+               error "failed to run multiop: $?"
+       drop_ldlm_cancel $MULTIOP $DIR2/$tfile Ow ||
+               error "failed to ldlm_cancel: $?"
+
+       umount_client $DIR2 || error "failed to unmount $DIR2: $?"
+       do_facet client munlink $DIR/$tfile ||
+               error "failed to unlink $DIR/$tfile: $?"
 
        # let the client reconnect
-       sleep 5
+       client_reconnect
        EVICT=$(do_facet client $LCTL get_param osc.$FSNAME-OST*.state | \
            awk -F"[ [,]" '/EVICTED]$/ { if (mx<$4) {mx=$4;} } END { print mx }')
 
-       [ ! -z "$EVICT" ] && [[ $EVICT -gt $BEFORE ]] || error "no eviction"
+       [ ! -z "$EVICT" ] && [[ $EVICT -gt $BEFORE ]] ||
+               (do_facet client $LCTL get_param osc.$FSNAME-OST*.state;
+                   error "no eviction: $EVICT before:$BEFORE")
 }
 run_test 19b "test expired_lock_main on ost (2867)"
 
+test_19c() {
+       local BEFORE=`date +%s`
+
+       mount_client $DIR2
+       $LCTL set_param ldlm.namespaces.*.early_lock_cancel=0
+
+       mkdir -p $DIR1/$tfile
+       stat $DIR1/$tfile
+
+#define OBD_FAIL_PTLRPC_CANCEL_RESEND 0x516
+       do_facet mds $LCTL set_param fail_loc=0x80000516
+
+       touch $DIR2/$tfile/file1 &
+       PID1=$!
+       # let touch to get blocked on the server
+       sleep 2
+
+       wait $PID1
+       $LCTL set_param ldlm.namespaces.*.early_lock_cancel=1
+       umount_client $DIR2
+
+       # let the client reconnect
+       sleep 5
+       EVICT=$(do_facet client $LCTL get_param mdc.$FSNAME-MDT*.state |
+          awk -F"[ [,]" '/EVICTED]$/ { if (mx<$4) {mx=$4;} } END { print mx }')
+
+       [ -z "$EVICT" ] || [[ $EVICT -le $BEFORE ]] || error "eviction happened"
+}
+run_test 19c "check reconnect and lock resend do not trigger expired_lock_main"
+
 test_20a() {   # bug 2983 - ldlm_handle_enqueue cleanup
        remote_ost_nodsh && skip "remote OST with nodsh" && return 0
 
@@ -635,7 +753,7 @@ test_23() { #b=4561
 }
 run_test 23 "client hang when close a file after mds crash"
 
-test_24() { # bug 11710 details correct fsync() behavior
+test_24a() { # bug 11710 details correct fsync() behavior
        remote_ost_nodsh && skip "remote OST with nodsh" && return 0
 
        mkdir -p $DIR/$tdir
@@ -649,9 +767,10 @@ test_24() { # bug 11710 details correct fsync() behavior
        rc=$?
        lctl set_param fail_loc=0x0
        client_reconnect
-       [ $rc -eq 0 ] && error_ignore 5494 "multiop didn't fail fsync: rc $rc" || true
+       [ $rc -eq 0 ] &&
+               error_ignore bz5494 "multiop didn't fail fsync: rc $rc" || true
 }
-run_test 24 "fsync error (should return error)"
+run_test 24a "fsync error (should return error)"
 
 wait_client_evicted () {
        local facet=$1
@@ -659,10 +778,44 @@ wait_client_evicted () {
        local varsvc=${facet}_svc
 
        wait_update $(facet_active_host $facet) \
-                "lctl get_param -n *.${!varsvc}.num_exports | cut -d' ' -f2" \
-                $((exports - 1)) $3
+               "lctl get_param -n *.${!varsvc}.num_exports | cut -d' ' -f2" \
+               $((exports - 1)) $3
 }
 
+test_24b() {
+       remote_ost_nodsh && skip "remote OST with nodsh" && return 0
+
+       dmesg -c > /dev/null
+       mkdir -p $DIR/$tdir
+       lfs setstripe $DIR/$tdir -s 0 -i 0 -c 1
+       cancel_lru_locks osc
+       multiop_bg_pause $DIR/$tdir/$tfile-1 Ow8192_yc ||
+               error "mulitop Ow8192_yc failed"
+
+       MULTI_PID1=$!
+       multiop_bg_pause $DIR/$tdir/$tfile-2 Ow8192_c ||
+               error "mulitop Ow8192_c failed"
+
+       MULTI_PID2=$!
+       ost_evict_client
+
+       kill -USR1 $MULTI_PID1
+       wait $MULTI_PID1
+       rc1=$?
+       kill -USR1 $MULTI_PID2
+       wait $MULTI_PID2
+       rc2=$?
+       lctl set_param fail_loc=0x0
+       client_reconnect
+       [ $rc1 -eq 0 -o $rc2 -eq 0 ] &&
+       error_ignore bz5494 "multiop didn't fail fsync: $rc1 or close: $rc2" ||
+               true
+
+       dmesg | grep "dirty page discard:" ||
+               error "no discarded dirty page found!"
+}
+run_test 24b "test dirty page discard due to client eviction"
+
 test_26a() {      # was test_26 bug 5921 - evict dead exports by pinger
 # this test can only run from a client on a separate node.
        remote_ost || { skip "local OST" && return 0; }
@@ -771,6 +924,7 @@ test_29a() { # bug 22273 - error adding new clients
        # fail abort so client will be new again
        fail_abort $SINGLEMDS
        client_up || error "reconnect failed"
+       wait_osc_import_state $SINGLEMDS ost FULL
        return 0
 }
 run_test 29a "error adding new clients doesn't cause LBUG (bug 22273)"
@@ -806,7 +960,8 @@ test_50() {
        rc=$?
        echo writemany returned $rc
        #these may fail because of eviction due to slow AST response.
-       [ $rc -eq 0 ] || error_ignore 13652 "writemany returned rc $rc" || true
+       [ $rc -eq 0 ] ||
+               error_ignore bz13652 "writemany returned rc $rc" || true
 }
 run_test 50 "failover MDS under load"
 
@@ -825,19 +980,21 @@ test_51() {
        SEQ="1 5 10 $(seq $TIMEOUT 5 $(($TIMEOUT+10)))"
         echo will failover at $SEQ
         for i in $SEQ
-          do
-          echo failover in $i sec
-          sleep $i
-          facet_failover $SINGLEMDS
+        do
+               #echo failover in $i sec
+               log "test_$testnum: failover in $i sec"
+               sleep $i
+               facet_failover $SINGLEMDS
         done
        # client process should see no problems even though MDS went down
        # and recovery was interrupted
        sleep $TIMEOUT
         kill -USR1 $CLIENT_PID
-       wait $CLIENT_PID 
+       wait $CLIENT_PID
        rc=$?
        echo writemany returned $rc
-       [ $rc -eq 0 ] || error_ignore 13652 "writemany returned rc $rc" || true
+       [ $rc -eq 0 ] ||
+               error_ignore bz13652 "writemany returned rc $rc" || true
 }
 run_test 51 "failover MDS during recovery"
 
@@ -906,57 +1063,58 @@ test_55() {
 
        mkdir -p $DIR/$tdir
 
+       # Minimum pass speed is 2MBps
+       local ddtimeout=64
+       # LU-2887/LU-3089 - set min pass speed to 500KBps
+       [ "$(facet_fstype ost1)" = "zfs" ] && ddtimeout=256
+
        # first dd should be finished quickly
        $LFS setstripe -c 1 -i 0 $DIR/$tdir/$tfile-1
-       dd if=/dev/zero of=$DIR/$tdir/$tfile-1 bs=32M count=4  &
+       dd if=/dev/zero of=$DIR/$tdir/$tfile-1 bs=32M count=4 &
        DDPID=$!
        count=0
        echo  "step1: testing ......"
-       while [ true ]; do
-           if [ -z `ps x | awk '$1 == '$DDPID' { print $5 }'` ]; then break; fi
-           count=$[count+1]
-           if [ $count -gt 64 ]; then
-               error "dd should be finished!"
-           fi
-           sleep 1
-       done    
+       while kill -0 $DDPID 2> /dev/null; do
+               let count++
+               if [ $count -gt $ddtimeout ]; then
+                       error "dd should be finished!"
+               fi
+               sleep 1
+       done
        echo "(dd_pid=$DDPID, time=$count)successful"
 
        $LFS setstripe -c 1 -i 0 $DIR/$tdir/$tfile-2
        #define OBD_FAIL_OST_DROP_REQ            0x21d
        do_facet ost1 lctl set_param fail_loc=0x0000021d
        # second dd will be never finished
-       dd if=/dev/zero of=$DIR/$tdir/$tfile-2 bs=32M count=4  &        
+       dd if=/dev/zero of=$DIR/$tdir/$tfile-2 bs=32M count=4 &
        DDPID=$!
        count=0
        echo  "step2: testing ......"
-       while [ $count -le 64 ]; do
-           dd_name="`ps x | awk '$1 == '$DDPID' { print $5 }'`"            
-           if [ -z  $dd_name ]; then 
-                ls -l $DIR/$tdir
-               echo  "debug: (dd_name=$dd_name, dd_pid=$DDPID, time=$count)"
-               error "dd shouldn't be finished!"
-           fi
-           count=$[count+1]
-           sleep 1
-       done    
+       while [ $count -le $ddtimeout ]; do
+               if ! kill -0 $DDPID 2> /dev/null; then
+                       ls -l $DIR/$tdir
+                       error "dd shouldn't be finished! (time=$count)"
+               fi
+               let count++
+               sleep 1
+       done
        echo "(dd_pid=$DDPID, time=$count)successful"
 
        #Recover fail_loc and dd will finish soon
        do_facet ost1 lctl set_param fail_loc=0
        count=0
        echo  "step3: testing ......"
-       while [ true ]; do
-           if [ -z `ps x | awk '$1 == '$DDPID' { print $5 }'` ]; then break; fi
-           count=$[count+1]
-           if [ $count -gt 500 ]; then
-               error "dd should be finished!"
-           fi
-           sleep 1
-       done    
+       while kill -0 $DDPID 2> /dev/null; do
+               let count++
+               if [ $count -gt $((ddtimeout + 440)) ]; then
+                       error "dd should be finished!"
+               fi
+               sleep 1
+       done
        echo "(dd_pid=$DDPID, time=$count)successful"
 
-        rm -rf $DIR/$tdir
+       rm -rf $DIR/$tdir
 }
 run_test 55 "ost_brw_read/write drops timed-out read/write request"
 
@@ -1004,7 +1162,10 @@ test_58() { # bug 11546
         lctl set_param fail_loc=0
         drop_bl_callback rm -f $DIR/$tfile
         wait $pid
-        do_facet client "df $DIR"
+        # the first 'df' could tigger the eviction caused by
+        # 'drop_bl_callback', and it's normal case.
+        # but the next 'df' should return successfully.
+        do_facet client "df $DIR" || do_facet client "df $DIR"
 }
 run_test 58 "Eviction in the middle of open RPC reply processing"
 
@@ -1027,12 +1188,12 @@ test_59() { # bug 10589
 run_test 59 "Read cancel race on client eviction"
 
 err17935 () {
-    # we assume that all md changes are in the MDT0 changelog
-    if [ $MDSCOUNT -gt 1 ]; then
-       error_ignore 17935 $*
-    else
-       error $*
-    fi
+       # we assume that all md changes are in the MDT0 changelog
+       if [ $MDSCOUNT -gt 1 ]; then
+               error_ignore bz17935 $*
+       else
+               error $*
+       fi
 }
 
 test_60() {
@@ -1114,14 +1275,24 @@ test_61()
 }
 run_test 61 "Verify to not reuse orphan objects - bug 17025"
 
+# test_62 as seen it b2_1 please do not reuse test_62
+#test_62()
+#{
+#      zconf_umount `hostname` $DIR
+#      #define OBD_FAIL_PTLRPC_DELAY_IMP_FULL   0x516
+#      lctl set_param fail_loc=0x516
+#      mount_client $DIR
+#}
+#run_test 62 "Verify connection flags race - bug LU-1716"
+
 check_cli_ir_state()
 {
         local NODE=${1:-$HOSTNAME}
         local st
         st=$(do_node $NODE "lctl get_param mgc.*.ir_state |
                             awk '/imperative_recovery:/ { print \\\$2}'")
-        [ $st != ON -o $st != OFF ] ||
-                error "Error state $st, must be ON or OFF"
+       [ $st != ON -o $st != OFF -o $st != ENABLED -o $st != DISABLED ] ||
+               error "Error state $st, must be ENABLED or DISABLED"
         echo -n $st
 }
 
@@ -1134,8 +1305,8 @@ check_target_ir_state()
 
         st=$(do_facet $target "lctl get_param -n $recovery_proc |
                                awk '/IR:/{ print \\\$2}'")
-        [ $st != ON -o $st != OFF ] ||
-                error "Error state $st, must be ON or OFF"
+       [ $st != ON -o $st != OFF -o $st != ENABLED -o $st != DISABLED ] ||
+               error "Error state $st, must be ENABLED or DISABLED"
         echo -n $st
 }
 
@@ -1221,19 +1392,30 @@ target_instance_match()
 
 test_100()
 {
-        do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
-                { skip "MGS without IR support"; return 0; }
+       do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
+               { skip "MGS without IR support"; return 0; }
+
+       # MDT was just restarted in the previous test, make sure everything
+       # is all set.
+       local cnt=30
+       while [ $cnt -gt 0 ]; do
+               nidtbl_versions_match && break
+               sleep 1
+               cnt=$((cnt - 1))
+       done
+
+       # disable IR
+       set_ir_status disabled
 
-        # disable IR
-        set_ir_status disabled
+       local prev_ver=$(nidtbl_version_client client)
 
         local saved_FAILURE_MODE=$FAILURE_MODE
         [ $(facet_host mgs) = $(facet_host ost1) ] && FAILURE_MODE="SOFT"
         fail ost1
 
         # valid check
-        nidtbl_versions_match &&
-                error "version must differ due to IR disabled"
+       [ $(nidtbl_version_client client) -eq $prev_ver ] ||
+               error "version must not change due to IR disabled"
         target_instance_match ost1 || error "instance mismatch"
 
         # restore env
@@ -1326,10 +1508,11 @@ test_103()
         stop mds1
 
         # We need this test because mds is like a client in IR context.
-        start mds1 $MDSDEV1 || error "MDS should start w/o mgs"
+        start mds1 $(mdsdevname 1) $MDS_MOUNT_OPTS ||
+               error "MDS should start w/o mgs"
 
         # start mgs and remount mds w/ ir
-        start mgs $MGSDEV
+        start mgs $(mgsdevname) $MGS_MOUNT_OPTS
         clients_up
 
         # remount client so that fsdb will be created on the MGS
@@ -1366,7 +1549,8 @@ test_104()
         clients_up
 
         local ir_state=$(check_target_ir_state ost1)
-        [ $ir_state = "OFF" ] || error "ir status on ost1 should be OFF"
+       [ $ir_state = "DISABLED" -o $ir_state = "OFF" ] ||
+               error "ir status on ost1 should be DISABLED"
 }
 run_test 104 "IR: ost can disable IR voluntarily"
 
@@ -1388,7 +1572,8 @@ test_105()
 
         # make sure lustre mount at $rcli disabling IR
         local ir_state=$(check_cli_ir_state $rcli)
-        [ $ir_state = OFF ] || error "IR state must be OFF at $rcli"
+       [ $ir_state = "DISABLED" -o $ir_state = "OFF" ] ||
+               error "IR state must be DISABLED at $rcli"
 
        # Since the client just mounted, its last_rcvd entry is not on disk.
        # Send an RPC so exp_need_sync forces last_rcvd to commit this export
@@ -1400,9 +1585,10 @@ test_105()
         [ $(get_ir_status) = "partial" ] || error "MGS IR state must be partial"
 
         fail ost1
-        # make sure IR on ost1 is OFF
+       # make sure IR on ost1 is DISABLED
         local ir_state=$(check_target_ir_state ost1)
-        [ $ir_state = "OFF" ] || error "IR status on ost1 should be OFF"
+       [ $ir_state = "DISABLED" -o $ir_state = "OFF" ] ||
+               error "IR status on ost1 should be DISABLED"
 
         # restore it
         MOUNTOPT=$old_MOUNTOPT
@@ -1413,14 +1599,215 @@ test_105()
         [ $(get_ir_status) = "full" ] || error "MGS IR status must be full"
 
         fail ost1
-        # make sure IR on ost1 is ON
+       # make sure IR on ost1 is ENABLED
         local ir_state=$(check_target_ir_state ost1)
-        [ $ir_state = "ON" ] || error "IR status on ost1 should be OFF"
+       [ $ir_state = "ENABLED" -o $ir_state = "ON" ] ||
+               error "IR status on ost1 should be ENABLED"
 
         return 0
 }
 run_test 105 "IR: NON IR clients support"
 
-complete $(basename $0) $SECONDS
+cleanup_106() {
+       trap 0
+       umount_client $DIR2
+       debugrestore
+}
+
+test_106() { # LU-1789
+       [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.3.50) ]] ||
+               { skip "Need MDS version at least 2.3.50"; return 0; }
+
+#define OBD_FAIL_MDC_LIGHTWEIGHT         0x805
+       $LCTL set_param fail_loc=0x805
+
+       debugsave
+       trap cleanup_106 EXIT
+
+       # enable lightweight flag on mdc connection
+       mount_client $DIR2
+
+       local MDS_NEXP=$(do_facet $SINGLEMDS \
+                        lctl get_param -n mdt.${mds1_svc}.num_exports |
+                        cut -d' ' -f2)
+       $LCTL set_param fail_loc=0
+
+       touch $DIR2/$tfile || error "failed to create empty file"
+       replay_barrier $SINGLEMDS
+
+       $LCTL set_param debug=console
+       $LCTL clear
+       facet_failover $SINGLEMDS
+
+       # lightweight connection must be evicted
+       touch -c $DIR2/$tfile || true
+       $LCTL dk $TMP/lustre-log-$TESTNAME.log
+       evicted=`awk '/This client was evicted by .*MDT0000/ {
+                                     print;
+                     }' $TMP/lustre-log-$TESTNAME.log`
+       [ -z "$evicted" ] && error "lightweight client not evicted by mds"
+
+       # and all operations performed by lightweight client should be
+       # synchronous, so the file created before mds restart should be there
+       $CHECKSTAT -t file $DIR/$tfile || error "file not present"
+       rm -f $DIR/$tfile
+
+       cleanup_106
+}
+run_test 106 "lightweight connection support"
+
+test_107 () {
+       local CLIENT_PID
+       local close_pid
+
+       mkdir -p $DIR/$tdir
+       # OBD_FAIL_MDS_REINT_NET_REP   0x119
+       do_facet $SINGLEMDS lctl set_param fail_loc=0x119
+       multiop $DIR/$tdir D_c &
+       close_pid=$!
+       mkdir $DIR/$tdir/dir_106 &
+       CLIENT_PID=$!
+       do_facet $SINGLEMDS lctl set_param fail_loc=0
+       fail $SINGLEMDS
+
+       wait $CLIENT_PID || rc=$?
+       checkstat -t dir $DIR/$tdir/dir_106 || return 1
+
+       kill -USR1 $close_pid
+       wait $close_pid || return 2
+
+       return $rc
+}
+run_test 107 "drop reint reply, then restart MDT"
+
+test_110a () {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       local remote_dir=$DIR/$tdir/remote_dir
+       local MDTIDX=1
+
+       mkdir -p $DIR/$tdir
+       drop_request "$LFS mkdir -i $MDTIDX $remote_dir" ||
+                                       error "lfs mkdir failed"
+       local diridx=$($GETSTRIPE -M $remote_dir)
+       [ $diridx -eq $MDTIDX ] || error "$diridx != $MDTIDX"
+
+       rm -rf $DIR/$tdir || error "rmdir failed"
+}
+run_test 110a "create remote directory: drop client req"
+
+test_110b () {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       local remote_dir=$DIR/$tdir/remote_dir
+       local MDTIDX=1
+
+       mkdir -p $DIR/$tdir
+       drop_reint_reply "$LFS mkdir -i $MDTIDX $remote_dir" ||
+                                       error "lfs mkdir failed"
+
+       diridx=$($GETSTRIPE -M $remote_dir)
+       [ $diridx -eq $MDTIDX ] || error "$diridx != $MDTIDX"
+
+       rm -rf $DIR/$tdir || error "rmdir failed"
+}
+run_test 110b "create remote directory: drop Master rep"
+
+test_110c () {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       local remote_dir=$DIR/$tdir/remote_dir
+       local MDTIDX=1
+
+       mkdir -p $DIR/$tdir
+       drop_update_reply $((MDTIDX + 1)) "$LFS mkdir -i $MDTIDX $remote_dir" ||
+                                               error "lfs mkdir failed"
+
+       diridx=$($GETSTRIPE -M $remote_dir)
+       [ $diridx -eq $MDTIDX ] || error "$diridx != $MDTIDX"
+
+       rm -rf $DIR/$tdir || error "rmdir failed"
+}
+run_test 110c "create remote directory: drop update rep on slave MDT"
+
+test_110d () {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       local remote_dir=$DIR/$tdir/remote_dir
+       local MDTIDX=1
+
+       mkdir -p $DIR/$tdir
+       $LFS mkdir -i $MDTIDX $remote_dir || error "lfs mkdir failed"
+
+       drop_request "rm -rf $remote_dir" || error "rm remote dir failed"
+
+       rm -rf $DIR/$tdir || error "rmdir failed"
+
+       return 0
+}
+run_test 110d "remove remote directory: drop client req"
+
+test_110e () {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       local remote_dir=$DIR/$tdir/remote_dir
+       local MDTIDX=1
+
+       mkdir -p $DIR/$tdir
+       $LFS mkdir -i $MDTIDX $remote_dir  || error "lfs mkdir failed"
+       drop_reint_reply "rm -rf $remote_dir" || error "rm remote dir failed"
+
+       rm -rf $DIR/$tdir || error "rmdir failed"
+
+       return 0
+}
+run_test 110e "remove remote directory: drop master rep"
+
+test_110f () {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       local remote_dir=$DIR/$tdir/remote_dir
+       local MDTIDX=1
+
+       mkdir -p $DIR/$tdir
+       $LFS mkdir -i $MDTIDX $remote_dir || error "lfs mkdir failed"
+       drop_update_reply $MDTIDX "rm -rf $remote_dir" ||
+                                       error "rm remote dir failed"
+
+       rm -rf $DIR/$tdir || error "rmdir failed"
+}
+run_test 110f "remove remote directory: drop slave rep"
+
+# LU-2844 mdt prepare fail should not cause umount oops
+test_111 ()
+{
+       [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.3.62) ]] ||
+               { skip "Need MDS version at least 2.3.62"; return 0; }
+
+       local mdsdev=$(mdsdevname ${SINGLEMDS//mds/})
+#define OBD_FAIL_MDS_CHANGELOG_INIT 0x151
+       do_facet $SINGLEMDS lctl set_param fail_loc=0x151
+       stop $SINGLEMDS || error "stop MDS failed"
+       start $SINGLEMDS $mdsdev && error "start MDS should fail"
+       do_facet $SINGLEMDS lctl set_param fail_loc=0
+       start $SINGLEMDS $mdsdev || error "start MDS failed"
+}
+run_test 111 "mdd setup fail should not cause umount oops"
+
+# LU-793
+test_112a() {
+       remote_ost_nodsh && skip "remote OST with nodsh" && return 0
+
+       do_facet_random_file client $TMP/$tfile 100K ||
+               error_noexit "Create random file $TMP/$tfile"
+
+       pause_bulk "cp $TMP/$tfile $DIR/$tfile" $TIMEOUT ||
+               error_noexit "Can't pause_bulk copy"
+
+       df $DIR
+       # expect cmp to succeed, client resent bulk
+       cmp $TMP/$tfile $DIR/$tfile ||
+               error_noexit "Wrong data has been written"
+       rm $DIR/$tfile ||
+               error_noexit "Can't remove file"
+       rm $TMP/$tfile
+}
+run_test 112a "bulk resend while orignal request is in progress"
+
+complete $SECONDS
 check_and_cleanup_lustre
 exit_status